
import javafx.ext.swing.SwingButton;
import javafx.scene.Scene;
import javafx.scene.text.Font;
import javafx.stage.Stage;
import javafx.animation.Timeline;
import javafx.animation.KeyFrame;
import javafx.scene.input.MouseEvent;

var x = 0.0;
var y = 0.0;

var timelineX = Timeline {
    repeatCount: Timeline.INDEFINITE
    keyFrames: [
        KeyFrame {
            time: 0.0s
            values: x => 0
        },
        KeyFrame {
            time: 0.01s
            values: x => 5
        },
        KeyFrame {
            time: 0.03s
            values: x => -5
        },
        KeyFrame {
            time: 0.04s
            values: x => 0
        },
    ]
};

var timelineY = Timeline {
    repeatCount: Timeline.INDEFINITE
    keyFrames: [
        KeyFrame {
            time: 0.0s
            values: y => 0
        },
        KeyFrame {
            time: 0.015s
            values: y => 5
        },
        KeyFrame {
            time: 0.045s
            values: y => -5
        },
        KeyFrame {
            time: 0.06s
            values: y => 0
        },
    ]
};

Stage {
    title: "shakeButton"
    scene: Scene {
        width: 200
        height: 200
        content: [
            SwingButton {
                translateX: bind x + 50
                translateY: bind y + 75
                text: "Shake!"
                font: Font {
                    size: 24
                }
                onMousePressed: function( e: MouseEvent ):Void {
                    timelineX.play();
                    timelineY.play();
                }
                onMouseReleased: function( e: MouseEvent ):Void {
                    timelineX.stop();
                    timelineY.stop();
                }
            }
        ]
    }
}